{ (c) Copyright 1995,1997 㭨 .. bunin@mes.djug.pyatigorsk.su }
{$C DemandLoad,Discardable}
Unit ExprComp;
{$B-,F+,A+,N+,R-,S-,V-,I-,G+,X+,T-}

Interface
Uses Calcer,X1,Def2x2,Hash2x2,TPInline,Diffy,UserFunc,MatrDef,Objects;

{$DEFINE UseDirect}

Type
 IdHandle=PHashCell;

 POutVar=^TOutVar;
 TOutVar=record
  HVar:PHashCell;
  Diff:boolean;
  Expo:boolean;
  F1,F2:byte
 end;

 PIdDef=^TIdDef;
 TIdDef=record
  Name:PText;
  Value:PFloat;
  Res:byte;
  Expo:boolean;
  F1,F2:byte
 end;

 PListColl=^TListColl;
 TListColl=object(TCollection)
  procedure FreeItem(Item:pointer);virtual;
 end;

 TIdsArray=array[0..1] of byte;
 PIdsArray=^TIdsArray;

const
 ObjCountInc=10;

Type

 P2x2Storage=^T2x2Storage;
 T2x2Storage=object(TACompilator)
  StandHash:PStandardHash; {  १. ᫮ }
  GlobalHash:PTermHash;    { .  (Var,Par,UserFunc) }
  CHash:PTermHash;         { ⥪騩  }
  ParList:PListColl;       { ᯨ᮪ ࠬ஢ Par }
  ProgType:T2x2ProgType;   { ⨯ ணࠬ }
  SubrList:PCollection;  { ᯨ᮪ ணࠬ  ᨢ - }

  function AddString(const Name:string):IdHandle;
  function AddParametr(const Name:string):IdHandle;
  function AddUserConst(const Name:string; Value:Float):boolean;
  function AddUserStrConst(const Name:string; const Value:string):boolean;
  function AddFunction(F:PFuncObject):IdHandle;
  function AddProcedure(F:PFuncObject):IdHandle;
  function AddArray(const Name:string; What:FArrayType; M:PMatrix):IdHandle;
  function AddUserType(const Name:string; TypeId:TUserVarType):word;
  function AddUserTypeVar(const Name:string; TypeId:TUserVarType):IdHandle;
  function AddUserObjType(Obj2x2Def:P2x2Object):boolean;
  function AddUserObjVar(const Name:TermString; ObjVar:PUserObject):boolean;
  function AddUserObjRefVar(const Name:TermString; Obj2x2Def:P2x2Object):IdHandle;
  function AddDirectCall(WhatCall:TSubrType; Name:TermString; ParCount:word;
   const Pars:TDirectCallPars; Return2x2:TReturnType; ReturnPas:TPasReturnType;
   FuncAddress:pointer; IsSimplified:boolean):boolean;
  function SetReadOnly(IdName:TermString):boolean;
  function GetIdData(IH:IdHandle):pointer;
  constructor Init;
  destructor Done; virtual;
  { 㦥 ⮤ }
  function NewString(const S:string; IsConst:boolean):PText;
  procedure InitHash;virtual;
  function FindIdent(const IdName:TermString; var R:pointer):boolean;virtual;
  procedure DeleteObject(P:PObject);virtual;
  function FindHash(IdName:TermString; Mask:word):PHashCell;
  function GetFreeObjId:TObjVarType;virtual;
  procedure FreeObjId(ObjId:TObjVarType);virtual;
 private
  ObjIds:PIdsArray;
  ObjIdsSize:integer;
  ObjIdsCount:integer;
  function CheckName1(Name:string; NType:OpsType):IdHandle;
  function CheckName2(Name:string; NType:OpsType):IdHandle;
 end;

 PExprCompilator=^TExprCompilator;
 TExprCompilator=object(T2x2Storage) {  ࠦ }
  EOFData:boolean;         { ਧ   }
  CurY:word;               { ⥪騩  ப  }
  DataStr:string;
  ATerms:array[boolean] of TToken;  { ⠡ ᥬ }
  CurTerm:boolean;         { ⥪騩  }
  State2x2:T2x2States;
  LibLoadCount:integer;

  { 㦥 ६ }
  FutureStrError:word;     {  訡  TransStrExpression }
  FutureError:word;        {  訡  TransExpression }
  IsDiff:boolean;
  NCalcs:word;             { ⥪. ᫮ . 権 }
  NLogCalcs:word;          { ⥪. ᫮ . 権 }
  NBraL:word;              { ⥪. ᫮ ᪮ (),-  logic-- }
  NBraE:word;              { ⥪. ᫮ ᪮ (),-  .- }
  NBrack:word;             { ⥪. ᫮ . ᪮ [] }
  SDataLen:byte;
  CurStPos:byte;
  ExNeed:boolean;          { ⥪. ਧ 㦭 -; 㦭, ᫨ }
                           { ᮤন Par,DoubleVar,Array,Polinom,UserFunc }
  ErrorTxt:string[3*MaxTermLen];
  ErrorData:longint;
  LibIdent:boolean;
  SearchObjMetod:boolean;

  constructor Init;
  procedure GetDataString(Var S:string);virtual;
  procedure InitHash;virtual;
  destructor Done; virtual;
  procedure SetModuleName(AName:TermString);
  function GetModuleName:TermString;

  function GetParNums:word;
  function GetParDesc(Num:integer; Var IdDef:TIdDef):boolean;
  { 㦥 ⮤ }
  procedure TranslateString(Var P:TExpression);
  function TranslateExpression(PlusSearch,Back:boolean):PTermTree;
  function TranslateStrExpression(Back:boolean):PTermTree;
  function TranslateUserExpression(UserId:TUserVarType; Exactly,OnlyIdent:boolean;
   var ByRef:word):PTermTree;
  procedure EJump0(i:integer);
  procedure EJump1(i:integer);
  procedure TranslateMath(Var P:TExpression; IsFunc:boolean);
  procedure TranslateUser(Var P:TExpression; UserId:TUserVarType);
  function TranslateLogic(LogSearch,Back:boolean):PLogicTree;
  procedure ValidReference(const ValidName:TermString);virtual;
  procedure GetTerm;
  procedure CheckRBra;
  procedure CheckLBra;
 private
  ErrorLevel:byte;       { ஢ 室  訡 teBraFromLogic }
  CurSpecial:boolean;
  SpecialWhat:byte;
  LastTree:PTermTree;    { -  ࠡ⪥ teBraFromLogic }
  UserConst:word;
  ModuleName:string;
  function AddConstant(Var V:extended):pointer;
  function AddTerm(P:PToken; Var N:string):PHashCell;
  procedure NewTerm;
  procedure TranslateFunc(T:PTermTree; IsFunc,IsDirect:boolean);
  function TranslateRelation(var W:byte):PBoolExpression;
  procedure TranslateObjPar(Var T:TExpression; Flags:word; var What:word; var Op:OpsType);
 end;

 P2x2Manager=^T2x2Manager;
 T2x2Manager=object(T2x2Storage) {  }
  procedure InitHash;virtual;
  destructor Done; virtual;
  function FindLibCalcer(LibName:TermString):PExprCompilator;
  function AddLib(Lib:PExprCompilator):boolean;
  procedure ValidModule(MName:TermString);
  procedure ValidBeforeCompile(MName:TermString);
  procedure DestroyModule(const MName:TermString);
  { 㦥 ⮤ }
  function FindLib(LibName:TermString; var LibHash:PHashCell):boolean;
  procedure RegisterCompilator(RC:PExprCompilator);
  procedure UnRegisterCompilator(RC:PExprCompilator);
  procedure DeleteFromGarbage(Lib:pointer);
 private
  Garbage:PCollection; { ᯨ᮪ ⨢ 㫥 }
  CompRegistry:PCollection; { ᯨ᮪ ⨢ ஢ }
 end;

function AddNewFunc(Count:word; Defs:pointer; Compilator:P2x2Storage):word;
function ScanOp(SOp,Er1,Er2:integer):integer;

var
 Manager2x2:P2x2Manager;

Implementation
Uses MyString,{$IFDEF UseDirect} StrD2x2 {$ELSE} StrFuncs {$ENDIF};

Type

 PfResize=^fResize;
 fResize=object(TUserProc)
  PM:Ppointer;
  L,C:PFloat;
  constructor Init;
  procedure Evaluate;virtual;
 end;

const
 Infinity:array[0..9] of byte=(0,0,0,0,0,0,0,128,255,127);

constructor fResize.Init;
begin
 Inherited Init('RESIZE',3);
 PM:=InsertAnyArrayPar;
 L:=InsertFloatPar(False); C:=InsertFloatPar(False);
end;

procedure fResize.Evaluate;
var M:PMatrix;
begin
 M:=PMatrix(PM^);
 M^.NewSize(Round(L^),Round(C^))
end;

function AddNewFunc(Count:word; Defs:pointer; Compilator:P2x2Storage):word;assembler;
var _ds,_si,CntRes:word;
asm
 mov CntRes,0
 mov dx,ds
 lds si,Defs
@2:
 lodsw
 push ax      { ⨯ }
 mov al,[si]  {   }
 push ds      {   }
 push si
 xor ah,ah
 add si,ax    { ய᪠  }
 inc si
 lodsw
 push ax      { - - }
 mov bx,4
 push ds      {  ⥫ - }
 push si
 mul bl       { ய⨬ ⥫ }
 add si,ax

 mov cx,4     { ⨯ + - }
@1:
 lodsw
 push ax
 loop @1

 lodsb
 xor ah,ah
 push ax     { IsSimplified }

 mov _ds,ds
 mov _si,si

 lds si,Compilator
 push ds
 push si
 mov ds,dx
 call T2x2Storage.AddDirectCall
 or al,al
 je @exit
 inc CntRes
 mov ax,Count
 cmp ax,CntRes
 je @exit
 mov dx,ds
 mov ax,_ds
 mov ds,ax
 mov si,_si
 jmp @2
@exit:
 mov ax,CntRes
end;

function ScanOp(SOp,Er1,Er2:integer):integer;assembler;
const Count=24;
asm
 mov ax,cs
 mov es,ax
 mov di,OFFSET @Ops
 mov ax,SOp
 mov cx,Count
 cld
 repne scasw
 jne @2  { not found }
 mov ax,Er1
 jmp @3
@Ops:
 dw opFPar,opFUknown,opFConst,opArrayVar,opPolinom,opStrArrVar,opMatrixVar
 dw opAnyArrVar,opSPar,opSUknown,opSConst,opUserVar,opObject,opObjectRef
 dw opParProc,opParFunc,opParStrFunc,opUserFunc,opStringFunc,opDirectFunc
 dw opDirectStrFunc,opUserProc,opDirectProc,opLib
@2:
 mov ax,Er2
@3:
end;

procedure TListColl.FreeItem(Item:pointer);
begin
 Dispose(POutVar(Item))
end;

constructor T2x2Storage.Init;
begin
 Inherited Init;
 TransError:=0;
 SubrList:=New(PCollection,Init(100,100));
 ParList:=New(PListColl,Init(5,5));
 InitHash; { InitHash ᫥ ।- SubrList,ParList !!! }
 ObjIds:=nil;
 ObjIdsSize:=0;
 ObjIdsCount:=0;
end;

destructor T2x2Storage.Done;
begin
 Dispose(StandHash,Done);
 Dispose(GlobalHash,Done);
 Dispose(SubrList,Done);
 Dispose(ParList,Done);
 If ObjIds<>nil then FreeMem(ObjIds,ObjIdsSize*ObjCountInc);
 Inherited Done;
end;

procedure T2x2Storage.InitHash;
begin
 GlobalHash:=New(PTermHash,Init(@Self,nil));
 CHash:=GlobalHash;
end;

function T2x2Storage.NewString(const s:string; IsConst:boolean):PText;
var P:PText; L:byte absolute s; i:byte;
begin
 If IsConst then i:=L+1 else i:=TextTermSize;
 P:=NewMem(i);
 If IsConst then FastMove(pointer(@s)^,P^,i) else P^:='';
 NewString:=P
end;

function T2x2Storage.FindHash(IdName:TermString; Mask:word):PHashCell;
var H:PHashCell;
begin
 IdName:=UpperCase(IdName);
 GetHashKey(IdName);
 GlobalHash^.Search(IdName,False,Mask,H);
 FindHash:=H
end;

function T2x2Storage.GetIdData(IH:IdHandle):pointer;
begin
 Case IH^.TermType of
  opFPar..opFConst,opUserVar: GetIdData:=@IH^.ValueF; { PFloat }
  opSPar..opSConst: GetIdData:=IH^.ValueP; { PText  }
  opObject,opObjectRef,opObjectType: GetIdData:=IH^.HData; { PUserObject,P2x2Object }
  opUserFunc,opUserProc,opStringFunc: GetIdData:=PFunction(IH^.HData)^.FuncCalc; { P2x2Function }
  else GetIdData:=nil
 end
end;

function T2x2Storage.SetReadOnly(IdName:TermString):boolean;
var H:PHashCell;
begin
 H:=FindHash(IdName,VarMask);
 If H=nil then SetReadOnly:=False
 else begin
  H^.HFlags:=H^.HFlags or off_ReadOnly;
  SetReadOnly:=True
 end
end;

function GetFreeBit(var Buf; Size:integer):word;near;assembler;
asm
 les di,Buf
 xor cx,cx
 xor bx,bx
@1:
 inc bx
 mov ax,es:[di]
@2:
 test ax,bx
 je @exit
 inc cx
 shl bx,1
 or bx,bx
 jne @2
 inc di
 inc di
 jmp @1
@exit:
 or ax,bx
 mov es:[di],ax
 mov ax,cx
 inc ax
end;

function T2x2Storage.GetFreeObjId:TObjVarType;
var k,i:integer; P:PIdsArray;
begin
 k:=ObjIdsSize*ObjCountInc*8; { ᫮ ⢥  }
 Inc(ObjIdsCount);
 If ObjIdsCount>k then begin
  Inc(ObjIdsSize);
  GetMem(P,ObjIdsSize*ObjCountInc);
  FillChar(P^,ObjIdsSize*ObjCountInc,0);
  If ObjIds<>nil then begin
   i:=(ObjIdsSize-1)*ObjCountInc;
   FastMoveWord(ObjIds^,P^,i div 2);
   FreeMem(ObjIds,i)
  end;
  ObjIds:=P;
 end;
 k:=GetFreeBit(ObjIds^,ObjIdsSize*ObjCountInc div 2);
 GetFreeObjId:=k
end;

procedure T2x2Storage.FreeObjId(ObjId:TObjVarType);assembler;
asm
  mov bx,ObjId
  sub bx,opObjType3
  dec bx
  mov ax,bx
  shr bx,3 { bx=bx div 8 }
  and ax,111b { ax=bx mod 8 }
  mov cx,1
  xchg ax,cx
  shl ax,cl
  not ax
  mov cx,ax
  les di,Self
  les di,es:[di].T2x2Storage.ObjIds
  mov al,byte ptr es:[di][bx]
  and al,cl
  mov byte ptr es:[di][bx],al
end;

procedure T2x2Storage.DeleteObject(P:PObject);
begin end;
function T2x2Storage.FindIdent(const IdName:TermString; var R:pointer):boolean;
begin end;

procedure T2x2Manager.InitHash;
var H:PHashCell;
begin
 Inherited InitHash;
 Garbage:=New(PCollection,Init(32,32));
 StandHash:=New(PStandardHash,Init(@Self,nil,True));
 {$IFDEF UseDirect}
 RegisterStrFuncs(@Self);
 {$ELSE}
 RegisterStrFuncs(StandHash); { 塞 ப - }
 {$ENDIF};
 AddUserConst('PI',Pi); {  ⠭ Pi }
 AddUserConst('INFINITY',0); {  ⠭ Inf }
 StandHash^.Search('INFINITY',False,AllMask,H);
 FastMoveWord(Infinity,H^.ValueF,5);
 AddUserConst('TRUE',1); {  ⠭ 1 }
 AddUserConst('FALSE',0); {  ⠭ 0 }
 {  -  ࠧ ᨢ }
 AddFunction(New(PfResize,Init));
 CreateTObject(User2x2TObject);
 AddUserObjType(User2x2TObject);
 AddFunction(CreateOCProc);
 AddUserObjRefVar('NIL',nil); {  ꥪ 뫪 nil }
 CompRegistry:=New(PCollection,Init(16,16));
end;

destructor T2x2Manager.Done;
begin
 Dispose(Garbage,Done);
 CompRegistry^.DeleteAll;
 Dispose(CompRegistry,Done);
 DoneUser;
 Inherited Done
end;

procedure T2x2Manager.RegisterCompilator(RC:PExprCompilator);
{  ⪮஢   ᯨ᮪ ⨢ ஢ }
begin
 { ᫨  - ﭭ, ᢮  砩  }
 If RC^.GetModuleName='' then RC^.SetModuleName(Format(Random(1),15,12));
 CompRegistry^.Insert(RC)
end;

procedure T2x2Manager.UnRegisterCompilator(RC:PExprCompilator);
{ 㤠   ᯨ᪠ ⨢ ஢ }
begin
 CompRegistry^.Delete(RC)
end;

procedure T2x2Manager.ValidBeforeCompile(MName:TermString);
{ ⮤ 뢠   室 ⥪ ணࠬ() MName,
   MName ᮡ ⪮஢ }
var i:integer; P:PExprCompilator; H:PHashCell;
begin
 MName:=UpperCase(MName);
 For i:=0 to CompRegistry^.Count-1 do begin
  P:=PExprCompilator(CompRegistry^.At(i));
  If P^.GetModuleName=MName then begin
   If (P^.ProgType=pt2x2Library) then begin
    {   ⠢塞,  ⠭ ਧ  㭨⮦ }
    GetHashKey(MName);
    If FindLib(MName,H) then H^.HData:=nil;
    Garbage^.Delete(P); { 㤠塞   ᯨ᪠ ⨢ 㫥 }
   end;
   Dispose(P,Done); { ࠧ蠥  }
   break
  end;
 end;
end;

procedure T2x2Manager.ValidModule(MName:TermString);
{ ⮤ 뢠   室 ⥪ ணࠬ() MName }
var i:integer;
begin
 MName:=UpperCase(MName);
 For i:=0 to CompRegistry^.Count-1 do
  PExprCompilator(CompRegistry^.At(i))^.ValidReference(MName)
end;

procedure T2x2Manager.DestroyModule(const MName:TermString);
{ 㭨⮦    ணࠬ }
begin
 ValidModule(MName);
 ValidBeforeCompile(MName)
end;

function T2x2Manager.FindLib(LibName:TermString; var LibHash:PHashCell):boolean;
var b:boolean; i:integer; P:PExprCompilator;
begin
 b:=StandHash^.Search(LibName,False,AllMask,LibHash) and (LibHash^.TermType=opLib);
 If b and (LibHash^.HData=nil) then begin {   㭨⮦ }
  { 饬    }
  For i:=0 to CompRegistry^.Count-1 do begin
   P:=PExprCompilator(CompRegistry^.At(i));
   If (P^.GetModuleName=LibName) and (P^.ProgType=pt2x2Library) then begin
    LibHash^.HData:=P;  { 諨 }
    FindLib:=True; exit
   end
  end;
  b:=False
 end;
 FindLib:=b
end;

function T2x2Manager.FindLibCalcer(LibName:TermString):PExprCompilator;
var H:PHashCell;
begin
 GetHashKey(LibName);
 If FindLib(LibName,H) then FindLibCalcer:=H^.HData else FindLibCalcer:=nil
end;

function T2x2Manager.AddLib(Lib:PExprCompilator):boolean;
var H:PHashCell; LibName:TermString;
begin
 AddLib:=False;
 ValidName(Lib^.ModuleName,TransError,ErrorX);
 If (TransError<>0) or (Lib^.TransError<>0) or not
  (csCompiled in Lib^.State2x2) then exit;
 If StandHash^.Search(Lib^.ModuleName,True,AllMask,H) and (H^.HData<>nil) then
  TransError:=teDoubleName
 else begin
  H^.TermType:=opLib;
  H^.HData:=Lib;
  Garbage^.Insert(Lib); {   ᯨ᮪ ⨢ 㫥 }
  AddLib:=True
 end
end;

procedure T2x2Manager.DeleteFromGarbage(Lib:pointer);
{ 㤠   ᯨ᪠ ⨢ 㫥 }
begin
 Garbage^.Delete(Lib)
end;

constructor TExprCompilator.Init;
var T:PToken;
begin
 Inherited Init;
 ProgType:=pt2x2Program;
 ModuleName:='';
 LibLoadCount:=0;
 CurTerm:=True;
 EOFData:=False;
 SDataLen:=0; CurStPos:=1; CurY:=0;
 NBraL:=0;
 ErrorLevel:=0;
 CurCompilator:=@Self;
 FutureError:=teEndExpected;
 State2x2:=[];
 SearchObjMetod:=False;
 NewTerm;
 With TopTerm^ do begin
  TermType:=opNull; X:=1; Y:=1; TermLen:=0;
 end;
end;

procedure TExprCompilator.SetModuleName(AName:TermString);
{   ணࠬ }
begin
 ModuleName:=UpperCase(AName)
end;

function TExprCompilator.GetModuleName:TermString;
{ 頥  ணࠬ }
begin
 GetModuleName:=ModuleName
end;

procedure TExprCompilator.InitHash;
begin
 Inherited InitHash;
 StandHash:=New(PStandardHash,Init(@Self,nil,False));
 StandHash^.AddFromHash(Manager2x2^.StandHash);
 GlobalHash^.AddFromHash(Manager2x2^.GlobalHash);
end;

destructor TExprCompilator.Done;
begin
 Inherited Done;
end;

procedure TExprCompilator.GetDataString(Var S:string);
begin end;
procedure TExprCompilator.ValidReference(const ValidName:TermString);
begin end;

function TExprCompilator.AddConstant(Var V:extended):pointer;
var P:PFloat;
begin
 P:=NewMem(SizeOf(Float));
 P^:=V;
 AddConstant:=P
end;

procedure TExprCompilator.NewTerm;
begin
 CurTerm:=not CurTerm;
 TopTerm:=@ATerms[CurTerm];
end;

function TExprCompilator.AddTerm(P:PToken; Var N:string):PHashCell;
var H:PHashCell;
begin
 If StandHash^.Find(N,H) or CHash^.Search(N,True,AllMask,H) then
  with P^ do begin
   TermType:=H^.TermType; TermWhat:=H^.What;
  end
 else begin
  H^.TermType:=opNewVar; P^.TermType:=opNewVar;
 end;
 AddTerm:=H
end;

function T2x2Storage.AddDirectCall(WhatCall:TSubrType; Name:TermString;
 ParCount:word; const Pars:TDirectCallPars; Return2x2:TReturnType;
 ReturnPas:TPasReturnType; FuncAddress:pointer; IsSimplified:boolean):boolean;
var F:PFunction; H:PHashCell; N1,N2,N3,N4,i,ifi,ife,iftmp,il,b:word;
    DC:PDirectCall;
begin
 AddDirectCall:=False;
 If ParCount>MaxFuncPars then begin
  TransError:=teTooManyPars;  exit
 end;
 ValidName(Name,TransError,ErrorX);
 If TransError<>0 then exit;
 If StandHash^.Search(Name,True,AllMask,H) then begin
  TransError:=teResword; exit; { ⠪  㦥  }
 end;

 {F:=NewMem(SizeOf(TFunction));}
 i:=SizeOf(_TFunction)+ParCount*SizeOf(TFuncPars);
 F:=NewMem(i);
 FillChar(F^,i{SizeOf(TFunction)},0);
 With F^ do begin
  FuncName:=H;
  NPars:=ParCount; {NParVars:=0;} MinFactArgs:=ParCount
 end;

 N1:=0; N2:=0; N3:=0; N4:=0;

 With H^ do begin
  HData:=F;
  What:=0;
  If WhatCall=wcProc then begin
   TermType:=opDirectProc;
   IsSimplified:=False
  end
  else begin
   If Return2x2=rtFloat then begin
    TermType:=opDirectFunc;
    Inc(N2); {  ⥫  - }
   end
   else begin
    TermType:=opDirectStrFunc;
    Inc(N3,2); {  㪠-  ப-१ }
    Inc(N1);   {  ⥫ ।   ப }
   end
  end
 end;

 b:=0;
 { ᫨ 㤥 b=ParCount,  foSimplified  ਭ }

 For i:=1 to ParCount do with Pars[i], F^.Pars[i] do begin
  Hash:=NewMem(SizeOf(THashCell));
  case ParType of
   dctFloat:
    If ByValue then begin
     TermType:=opFUknown; Inc(b)
    end
    else TermType:=opFPar;
   dctString:
    If ByValue then begin
     TermType:=opSUknown; Inc(b)
    end
    else TermType:=opSPar;
   dctAnyArray: TermType:=opAnyArrVar;
   dctArray   : TermType:=opArrayVar;
   dctStrArray: TermType:=opStrArrVar;
   dctUserType1..dctUserType2: begin
    If ByValue then TermType:=opUserVar else TermType:=opUserPar;
    Hash^.What:=ParType;
   end;
   dctObjType1..dctObjType2: begin
    Hash^.What:=ParType;
    UTFlag:=0;
    If PascalType=pptObjectRef then begin
     TermType:=opObjectRef;
     If not ByValue then UTFlag:=utfByPar
    end
    else TermType:=opObject;
   end;
   dctObjType: TermType:=opObjectType;
  end;
  Hash^.TermType:=TermType;

  Inc(N1); { ࠧ TCallPrepare }
  case PascalType of
   pptByte..pptPointer,pptDouble:
    If not ByValue then Inc(N2); { ࠧ AfterReturns }
  end;
  { - ࠧ CallStack }
  If not ByValue then begin
   Inc(N3,2);
   case PascalType of
    pptByte..pptInt: Inc(N4);
    pptWord..pptPointer: Inc(N4,2);
    pptDouble: Inc(N4,4)
   end
  end
  else
   case PascalType of
    pptByte..pptWord: Inc(N3);
    pptLong,pptPointer,pptString,pptArray,pptObject,pptObjectRef,pptObjectType:
     Inc(N3,2);
    pptDouble: Inc(N3,4);
    pptExtended: Inc(N3,5);
   end
 end;

 il:=N1+N2;
 { ।塞 TDirectCall }
 DC:=NewMem(SizeOf(TDirectCall)+(N3-1)*SizeOf(TDirectStack));
 F^.FuncCalc:=DC;
 with DC^ do begin
  TemplatePrep:=NewMem(il*SizeOf(TCallPrepare));
  TmpAr:=NewMem(N4*SizeOf(word));
  FuncAdr:=FuncAddress
 end;

 { 塞 TemplatePrep }
 ifi:=N1; ife:=N3*2; iftmp:=0;

 If (WhatCall=wcFunc) and (Return2x2=rtString) then
  with DC^.TemplatePrep^[ParCount] do begin
   Dec(ife,4);  { ।   ࠧ pointer }
   ToOfs:=ife;  { ᬥ饭  CallStack }
   What:=word(pctP2P) { pointer->pointer }
  end;

 For i:=1 to ParCount do
  with Pars[i], DC^.TemplatePrep^[i-1] do begin
   case PascalType of
    pptByte..pptInt: begin
     If ByValue then begin
      What:=word(pctE2I); { extended->int }
      Dec(ife,2); { ।   ࠧ word }
     end
     else begin
      {  맮 - }
      Dec(ife,4); { ।   ࠧ pointer }
      What:=word(pctPE2I); { extended->word->^word }
      Aux:=@DC^.TmpAr^[iftmp];
      Inc(iftmp);    { ᤢ  ᫮ }
      longint(From):=ifi;
      { ᫥ 맮 - }
      DC^.TemplatePrep^[ifi].Aux:=Aux;
      DC^.TemplatePrep^[ifi].What:=word(pctI2E);
      Inc(ifi);
     end;
    end;
    pptWord..pptPointer:begin
     If (PascalType=pptWord) and ByValue then Dec(ife,2) { ।   ࠧ word }
     else Dec(ife,4); { ।   ࠧ longint }
     If ByValue then
      If PascalType=pptWord then What:=word(pctE2W) { extended->word }
      else What:=word(pctE2L) { extended->longint }
     else begin
      {  맮 - }
      What:=word(pctPE2L); { extended->longint->^longint }
      Aux:=@DC^.TmpAr^[iftmp];
      Inc(iftmp,2);    { ᤢ  longint }
      longint(From):=ifi;
      { ᫥ 맮 - }
      DC^.TemplatePrep^[ifi].Aux:=Aux;
      DC^.TemplatePrep^[ifi].What:=word(pctL2E);
      Inc(ifi);
     end
    end;
    pptDouble:begin
     If ByValue then begin
      What:=word(pctE2D); { extended->double }
      Dec(ife,8) { ।   ࠧ double }
     end
     else begin
      {  맮 - }
      Dec(ife,4); { ।   ࠧ pointer }
      What:=word(pctPE2D); { extended->double->^double }
      Aux:=@DC^.TmpAr^[iftmp];
      Inc(iftmp,4);    { ᤢ  double }
      longint(From):=ifi;
      { ᫥ 맮 - }
      DC^.TemplatePrep^[ifi].Aux:=Aux;
      DC^.TemplatePrep^[ifi].What:=word(pctD2E);
      Inc(ifi);
     end
    end;
    pptExtended:begin
     If ByValue then begin
      What:=word(pctE2E); { extended->extended }
      Dec(ife,10) { ।   ࠧ extended }
     end
     else begin
      What:=word(pctP2P); { pointer->pointer }
      Dec(ife,4); { ।   ࠧ pointer }
      longint(From):=-1;
     end
    end;
    pptString:begin
     Dec(ife,4);  { ।   ࠧ pointer }
     If ByValue then What:=word(pctPP2P) { ^pointer->pointer }
     else What:=word(pctP2P) { pointer->pointer }
    end;
    pptArray,pptObject,pptObjectType:begin
     Dec(ife,4);  { ।   ࠧ pointer }
     What:=word(pctPP2P) { ^pointer->pointer }
    end;
    pptObjectRef:begin
     Dec(ife,4);  { ।   ࠧ pointer }
     If ByValue then What:=word(pctPP2P) { ^pointer->pointer }
     else What:=word(pctP2P) { pointer->pointer }
    end
   end;
   ToOfs:=ife; { ᬥ饭  CallStack }
  end;

 If (WhatCall=wcFunc) and (Return2x2=rtFloat) then
  with DC^.TemplatePrep^[ifi] do What:=word(ReturnPas) or $100;

 If IsSimplified and (b=ParCount) then F^.FuncFlags:=ffSimpleIfAllConst
 else F^.FuncFlags:=0;

 with DC^ do begin
  CallStackSize:=N3;
  PrepareSize:=N1;
  AfterPrepare:=N2
 end;
 AddDirectCall:=True
end;

function T2x2Storage.CheckName1(Name:string; NType:OpsType):IdHandle;
var H:PHashCell;
begin
 CheckName1:=nil;
 ValidName(Name,TransError,ErrorX);
 If TransError<>0 then exit;

 If StandHash^.Find(Name,H) then TransError:=teResword
 else
  If GlobalHash^.Search(Name,True,AllMask,H) then TransError:=teDoubleName
  else begin
   H^.TermType:=NType; CheckName1:=H;
  end
end;

function T2x2Storage.CheckName2(Name:string; NType:OpsType):IdHandle;
var H:PHashCell;
begin
 CheckName2:=nil;
 ValidName(Name,TransError,ErrorX);
 If TransError<>0 then exit;
 If StandHash^.Search(Name,True,AllMask,H) then TransError:=teDoubleName
 else begin
  H^.TermType:=NType; CheckName2:=H;
 end
end;

function T2x2Storage.AddParametr(const Name:string):IdHandle;
var H:PHashCell; OV:POutVar;
begin
 H:=CheckName1(Name,opFPar);
 AddParametr:=H;
 If H=nil then exit;
 New(OV);
 With OV^ do begin
  HVar:=H;
  Diff:=False; Expo:=False;
  F1:=stFormat1; F2:=stFormat2
 end;
 ParList^.Insert(OV);
end;

function T2x2Storage.AddUserConst(const Name:string; Value:Float):boolean;
var H:PHashCell;
begin
 H:=CheckName2(Name,opFConst);
 If H=nil then AddUserConst:=False
 else begin
  H^.ValueF:=Value;
  AddUserConst:=True;
 end
end;

function T2x2Storage.AddUserStrConst(const Name:string; const Value:string):boolean;
var H:PHashCell;
begin
 H:=CheckName2(Name,opSConst);
 If H=nil then AddUserStrConst:=False
 else begin
  H^.ValueP:=NewString(Value,True);
  AddUserStrConst:=True;
 end
end;

function T2x2Storage.AddUserType(const Name:string; TypeId:TUserVarType):word;
var H:PHashCell;
begin
 H:=CheckName2(Name,opUserType);
 If H=nil then AddUserType:=0
 else begin
  AddUserType:=TypeId;
  H^.What:=TypeId
 end
end;

function T2x2Storage.AddUserTypeVar(const Name:string; TypeId:TUserVarType):IdHandle;
var H:PHashCell;
begin
 H:=CheckName1(Name,opUserVar);
 If H<>nil then H^.What:=TypeId;
 AddUserTypeVar:=H
end;

function T2x2Storage.AddString(const Name:string):IdHandle;
var H:PHashCell;
begin
 H:=CheckName1(Name,opSPar);
 AddString:=H;
 If H<>nil then H^.ValueP:=NewMem(TextTermSize);
end;

function T2x2Storage.AddFunction(F:PFuncObject):IdHandle;
begin
 If F^.F.FuncFlags and ffPersistant=0 then SubrList^.Insert(F);
 If F^.Register(StandHash) then AddFunction:=F^.HFunc else AddFunction:=nil
end;

function T2x2Storage.AddProcedure(F:PFuncObject):IdHandle;
begin
 AddProcedure:=AddFunction(F)
end;

function T2x2Storage.AddArray(const Name:string; What:FArrayType; M:PMatrix):IdHandle;
const C:array[FArrayType] of OpsType=(opArrayVar,opStrArrVar);
var H:PHashCell; S:PStructDef;
begin
 H:=CheckName1(Name,C[What]);
 AddArray:=H;
 SubrList^.Insert(M);
 If H<>nil then begin
  S:=NewMem(SizeOf(TStructDef));
  H^.HData:=S;
  S^.Data:=M; S^.NameHash:=H;
 end;
end;

function T2x2Storage.AddUserObjType(Obj2x2Def:P2x2Object):boolean;
var H:PHashCell;
begin
 If Obj2x2Def^.Name<>'' then begin
  H:=CheckName2(Obj2x2Def^.Name,opObjectType);
  If H=nil then begin
   AddUserObjType:=False; exit
  end
  else begin
   H^.HData:=Obj2x2Def; H^.What:=Obj2x2Def^.ObjId
  end
 end;
 SubrList^.Insert(Obj2x2Def);
 AddUserObjType:=True;
end;

function T2x2Storage.AddUserObjVar(const Name:TermString; ObjVar:PUserObject):boolean;
var H:PHashCell;
begin
 H:=CheckName1(Name,opObject);
 If H=nil then AddUserObjVar:=False
 else begin
  H^.HData:=ObjVar;
  H^.What:=ObjVar^.GetObjDef^.ObjId;
  SubrList^.AtInsert(0,ObjVar); { ⠢ ꥪ ࠭ ⥫ }
  AddUserObjVar:=True;
 end
end;

function T2x2Storage.AddUserObjRefVar(const Name:TermString; Obj2x2Def:P2x2Object):IdHandle;
var H:PHashCell;
begin
 H:=CheckName1(Name,opObjectRef);
 If H=nil then AddUserObjRefVar:=nil
 else begin
  H^.HData:=Obj2x2Def;
  If Obj2x2Def=nil then begin
   H^.What:=0; H^.TermType:=opNil
  end
  else H^.What:=Obj2x2Def^.ObjId;
  AddUserObjRefVar:=H
 end
end;

procedure TExprCompilator.GetTerm;
Label Sorry;
var Len,L,i:integer; TermName:TermString; P:P2x2Storage; Fl:word;

function GetWord:boolean;
var t,cod,K,Iold:integer; IsNum:boolean; Value:extended; Op:OpsType; S:TextTerm;
begin
 GetWord:=False;
 While L>Len do begin
  Inc(CurY);
  GetDataString(DataStr);
  If EOFData then begin
   NewTerm;
   TopTerm^.TermType:=opEndData;
   With ATerms[not CurTerm] do begin
    TopTerm^.X:=X+TermLen; TopTerm^.Y:=Y; TermName:=''
   end;
   exit
  end;

  Len:=Pos('//',DataStr);
  If Len=0 then Len:=Length(DataStr) else Dec(Len);
  While (Len>0) and (DataStr[Len]<=#32) do Dec(Len);
  L:=1;
  DataStr[0]:=chr(Len);
  CurSpecial:=True;
 end; { while }
 SDataLen:=Len;

 While DataStr[L]<=#32 do Inc(L);
 Iold:=L;
 IsNum:=IsNumber(DataStr[Iold]);
 If IsNum then SpecialString[scPoint]:=' ';

 If CurSpecial then
  While (L<=Len) and (IsSpecial(DataStr[L],SpecialWhat)=False) do Inc(L);

 NewTerm;

 If L=Iold then begin { ᯥ.ᨬ }
  CurSpecial:=True;
  Op:=SpecialChars[SpecialWhat].SType;
  t:=SpecialChars[SpecialWhat].What;

  If (L<Len) and (SpecialWhat>scRBrack) then { :!<> }
   Case SpecialWhat of
    scText:begin
     Inc(IOld);
     L:=IOld;
     While (L<=Len) and (DataStr[L]<>TextChar) do Inc(L);
     If L>Len then ErrorJump(0,Len,CurY,teTextEndExpected);
     Inc(L);
     CurSpecial:=True;

     With TopTerm^ do begin
      TermLen:=0;
      X:=IOld-1; Y:=CurY;
      TermType:=opStringConst;
      S:=Copy(DataStr,IOld,L-IOld-1);
      Ref:=NewString(S,True);
      exit
     end
    end;

    scL:
     case DataStr[L+1] of
      GreatChar:begin
       t:=rtNE; Inc(L)
      end;
      AssignChar:begin
       t:=rtLE; Inc(L)
      end;
     end;

    scG:
     If DataStr[L+1]=AssignChar then begin
      t:=rtGE; Inc(L)
     end;

    scColon..scV:
     If DataStr[L+1]=AssignChar then begin
      If SpecialWhat=scColon then begin
       t:=rtE; Op:=opAssign
      end
      else begin
       t:=rtNE; Op:=opRel
      end;
      Inc(L)
     end;
   end; { case }
  Inc(L);
  With TopTerm^ do begin
   TermLen:=L-Iold;
   X:=Iold; Y:=CurY;
   TermType:=Op;
   TermWhat:=t;
  end
 end { If }

 else begin
  If IsNum then begin
   SpecialString[scPoint]:=PointChar;
   Op:=opConst;
   If (SpecialWhat<3) and ((byte(DataStr[L-1]) or $20)=byte('e')) then begin
    Inc(L);
    While (L<=Len) and (IsSpecial(DataStr[L],SpecialWhat)=False) do Inc(L);
    CurSpecial:=True
   end
   else CurSpecial:=SpecialWhat=scBlank;
   With TopTerm^ do begin
    TermLen:=L-Iold; X:=Iold; Y:=CurY;
    TermType:=opConst;
    Val(Copy(DataStr,Iold,TermLen),Value,cod);
    If cod<>0 then begin
     If IsLetter(TermName[byte(cod)]) then TermWhat:=teMathExpected
     else
      If cod>Length(TermName) then TermWhat:=teBigFloat else TermWhat:=teSyntax;
     X:=X+cod-1;
     ErrorJump(0,X,Y,TermWhat)
    end
    else Ref:=AddConstant(Value);
   end;
  end
  else begin
   CurSpecial:=SpecialWhat=scBlank;
   GetWord:=True;
   With TopTerm^ do begin
    TermLen:=L-Iold;
    TermName:=Copy(DataStr,Iold,TermLen);
    X:=Iold; Y:=CurY;
    IsDiff:=False;
    K:=GetHashKey(TermName);
    If K>0 then
     Case TermName[K] of
      Diff1Char,Diff2Char:
       If K=TermLen then IsDiff:=True else ErrorJump(0,X+K-1,Y,teIncorrectChar);
       else ErrorJump(0,X+K-1,Y,teIncorrectChar);
     end;
   end
  end
 end;
end;

procedure DoObject(OType,SelfType:P2x2Object; IsRef,ByRef:boolean; PObj:PObjScan);
 procedure GetRefType(P:PObjFieldDef);
 begin
  with TopTerm^ do
   case P^.FType of
    opFPar: TermType:=opRefPar;
    opUserVar: begin
     TermType:=opRefUser; TermWhat:=P^.UType
    end;
    opSPar: TermType:=opRefString;
    opArrayVar: TermType:=opRefArrayVar;
    opStrArrVar: TermType:=opRefStrArrVar;
   end
 end;

 function NewObjTrans(N:integer; AData:pointer; ADef:P2x2Object; APrev:PObjScan):PObjScan;
 var Q:PObjScan;
 begin
  Q:=NewMem(SizeOf(TObjScan));
  with Q^ do begin
   FieldNum:=N;
   OData:=AData;
   ObjDef:=ADef;
   Prev:=APrev
  end;
  NewObjTrans:=Q
 end;

var AObjType:P2x2Object; it,FldNum:integer; PD:PObjFieldDef; U:pointer;
    PF:PFieldRef; H:PHashCell; b:boolean; PQ:PObjScan; ch:char;
begin
 If PObj=nil then H:=TopTerm^.Ref; {  ꥪ/ꥪ⭮ 뫪 }
 { - ⨯ ꥪ }
 If OType<>nil then begin
  {  ਢ ⨯ }
  If not IsRef and (SelfType=nil) then begin
   {  砥 ਢ  ꥪ ஢ਬ ᮢ⨬ }
   {  ꥪ⭮ 뫪 ᪠  ਢ }
   If not ByRef then { complex.c / c.complex.c }
    AObjType:=PUserObject(H^.HData)^.GetObjDef
   else AObjType:=PObj^.ObjDef;  { c^.complex.c / c.c^.complex.c }
   If not AObjType^.ObjectIsParent(OType^.ObjId) then
     with TopTerm^ do ErrorJump(0,X,Y,teBadObjectPriv);
  end;
  AObjType:=OType
 end
 else
  If IsRef then { 뫪  ꥪ }
   If not ByRef then AObjType:=H^.HData { c^.x / c.c^.x }
   else AObjType:=PObj^.ObjDef  { c^.c^.x / c^.c.c^.x }
  else { .ꥪ }
   If not ByRef then { c.x / c.c.x }
    AObjType:=PUserObject(H^.HData)^.GetObjDef
   else AObjType:=PObj^.ObjDef;  { c^.c.x / c.c^.c.x }

 If (L<=Len) and ((DataStr[L]=PointChar) or (DataStr[L]=AmperChar)) then begin
  ch:=DataStr[L];
  Inc(L);
  CurSpecial:=True;
  If not GetWord then
   with TopTerm^ do ErrorJump(1,X,Y,teObjIdentExpected);

  it:=AObjType^.FindIdent(TermName,FldNum,PD);
  case it of
   oitField:begin { 筮  }
    If SelfType<>nil then
     with TopTerm^ do ErrorJump(0,X,Y,teObjOrMethIdExpected);
    If not ByRef and not IsRef then with TopTerm^ do begin
     Ref:=PUserObject(H^.HData)^.GetFieldHash(FldNum);
     TermType:=PHashCell(Ref)^.TermType;
     TermWhat:=PHashCell(Ref)^.What
    end
    else begin
     PF:=NewMemTmp(SizeOf(TFieldRef));
     with PF^ do begin
      FieldNum:=FldNum;
      If PObj=nil then Obj:=NewObjTrans(0,@H^.HData,AObjType,nil)
      else Obj:=PObj;
      FFlags:=PD^.FldFlags and off_ReadOnly; { 뤥塞 ⮫쪮   }
     end;
     TopTerm^.Ref:=PF;
     If PD^.FType=opUserVar then TopTerm^.TermWhat:=PD^.UType;
     GetRefType(PD)
    end
   end;
   oitObject:begin { -ꥪ }
    If not ByRef and not IsRef then with TopTerm^ do begin
     Ref:=PUserObject(H^.HData)^.GetFieldHash(FldNum);
     TopTerm^.TermType:=opObject;
     DoObject(SelfType,nil,False,False,nil)
    end
    else begin
     If IsRef and not ByRef then U:=@H^.HData else U:=PObj;
     PQ:=NewObjTrans(FldNum,U,P2x2Object(PD^.Data),PObj);
     TopTerm^.Ref:=PQ;
     TopTerm^.TermType:=opRefObject;
     Fl:=PD^.FldFlags and off_ReadOnly;
     DoObject(SelfType,nil,False,IsRef or ByRef,PQ)
    end
   end;
   oitRefObject:begin
    If not ByRef and not IsRef then with TopTerm^ do begin
     Ref:=PUserObject(H^.HData)^.GetFieldHash(FldNum);
     TopTerm^.TermType:=opObjectRef;
     DoObject(SelfType,nil,True,False,nil)
    end
    else begin
     If IsRef and not ByRef then U:=@H^.HData else U:=PObj;
     PQ:=NewObjTrans(FldNum,U,P2x2Object(PD^.Data),PObj);
     TopTerm^.Ref:=PQ;
     TopTerm^.TermType:=opRefObjectRef;
     Fl:=PD^.FldFlags and off_ReadOnly;
     DoObject(SelfType,nil,True,True,PQ)
    end
   end;
   oitMethod:begin
    If (SelfType<>nil) and not AObjType^.ObjectIsParent(SelfType^.ObjId) then
     with TopTerm^ do ErrorJump(0,X,Y,teBadObjectPriv);
    U:=NewMemTmp(SizeOf(TFuncCall));
    with PFuncCall(U)^ do begin
     Func:=PD^.Data^.HData; { PFunction }
     FuncIndex:=PD^.Num; {  ⮤ }
     TopTerm^.TermType:=PD^.Data^.TermType;
     b:=Func^.FuncFlags and ffVirtual=0;
     If (SelfType<>nil) or not IsRef or b then begin
      { ᪨ 맮 }
      CallFlags:=0;
      If not b then with TopTerm^ do
       { ⥬ ᪨ 맮 㠫 ⮤ }
       case TermType of
        opParFunc: TermType:=opUserFunc;
        opParProc: TermType:=opUserProc;
        opParStrFunc: TermType:=opStringFunc;
       end;
     end
     else CallFlags:=cfVirtual;
     {  ꥪ }
     If PObj=nil then CallObj:=H {  ꥪ }
     else begin { ꥪ ⥭ }
      CallFlags:=CallFlags or cfRefObj;
      CallObj:=PObj
     end
    end;
    TopTerm^.Ref:=U;
    TopTerm^.TermWhat:=1;
   end;
   oitUknown:begin
    b:=StandHash^.Find(TermName,H);
    If b and (H^.TermType=opObjectType) then begin
     If ch=AmperChar then begin
      If not IsRef and not AObjType^.ObjectIsParent(H^.What) then
       with TopTerm^ do ErrorJump(0,X,Y,teBadObjectPriv);
      U:=H^.HData;
     end
     else U:=OType;
     with ATerms[not CurTerm] do begin
      TopTerm^.Ref:=Ref;
      TopTerm^.TermType:=TermType;
      TopTerm^.TermWhat:=TermWhat;
      TopTerm^.CObjType:=CObjType;
     end;
     DoObject(U,H^.HData,IsRef,ByRef,PObj)
    end
    else
     with TopTerm^ do ErrorJump(1,X,Y,teObjIdentExpected);
   end
  end; { case }
 end
 else begin
  If SelfType<>nil then
   with TopTerm^ do ErrorJump(1,X,Y,tePointExpected);
  with TopTerm^ do begin
   CObjType:=AObjType;
   If PObj=nil then TFlags:=PHashCell(Ref)^.HFlags else TFlags:=Fl
  end
 end
end;

procedure DoObjectDef;
var Q:P2x2Object; it,FldNum:integer; PD:PObjFieldDef; P:PFunction;
begin
 If (L<=Len) and (DataStr[L]=PointChar) then begin
  Inc(L);
  CurSpecial:=True;
  Q:=PHashCell(TopTerm^.Ref)^.HData;
  If not GetWord then
   with TopTerm^ do ErrorJump(1,X,Y,teObjIdentExpected);
  If SearchObjMetod then begin
   it:=Q^.FindIdent(TermName,FldNum,PD);
   If it<>oitMethod then EJump0(teMethodIdExpected);
   P:=PFunction(PD^.Data^.HData);
   If P^.FuncName^.Nop1=nil then EJump0(teMethodReDef);
   TopTerm^.Ref:=P;
   TopTerm^.TermType:=opMethodDef;
  end
  else begin
   TopTerm^.Ref:=AddTerm(TopTerm,TermName);
   case TopTerm^.TermType of
    opObject: DoObject(Q,nil,False,False,nil);
    opObjectRef: DoObject(Q,nil,True,False,nil);
    else EJump1(teObjIdentExpected)
   end
  end
 end
end;

begin
 L:=CurStPos;
 Len:=SDataLen;
 LibIdent:=False;
 If GetWord then begin
  With TopTerm^ do Ref:=AddTerm(TopTerm,TermName);

Sorry:
   With TopTerm^ do
    case TermType of
     opLib:
      If (L<=Len) and (DataStr[L]=PointChar) then begin
       Inc(L);
       CurSpecial:=True;
       P:=PHashCell(Ref)^.HData;
       If not GetWord then ErrorJump(1,X,Y,teLibIdentExpected);
       With TopTerm^ do begin
        If not P^.FindIdent(TermName,Ref) then ErrorJump(0,X,Y,teUknownIdent);
        TermType:=PHashCell(Ref)^.TermType;
        TermWhat:=PHashCell(Ref)^.What;
        LibIdent:=True;
        case TermType of
         opObject,opObjectRef,opObjectType: goto Sorry;
        end
       end;
      end;
     opObject: DoObject(nil,nil,False,False,nil);
     opObjectType: DoObjectDef;
     opObjectRef: DoObject(nil,nil,True,False,nil);
    end; { case }
 end;
 CurStPos:=L;
end;

procedure TExprCompilator.TranslateFunc(T:PTermTree; IsFunc,IsDirect:boolean);
var K:PFuncFacts; P,Q,F:PFunction; B:boolean; i,j,N,l:word; Op,Op1:OpsType;
    Old:integer; Last:PMultiParRec; AByValue,ByRef:boolean;
{ ࠭ 맮 -/楤 }

 function OpIsArray(Ot:OpsType):boolean;near;
 begin
  case Ot of
   opArrayVar..opAnyArrVar,opRefArrayVar,opRefStrArrVar: OpIsArray:=True;
   else OpIsArray:=False;
  end
 end;

 function EqualArrayType(Ot,Ot1:OpsType):boolean;near;
 begin
  case Ot of
   opRefArrayVar: EqualArrayType:=Ot1=opArrayVar;
   opRefStrArrVar: EqualArrayType:=Ot1=opStrArrVar;
   else EqualArrayType:=False
  end
 end;

 procedure NewMP;near;
 var MP:PMultiParRec;
 begin
  MP:=NewMemTmp(SizeOf(TMultiParRec));
  MP^.Prev:=Last;
  Last:=MP;
  MP^.ByValue:=True;
 end;

 procedure IncNCalcs(Delta:integer);near;
 begin
  With P^ do begin
   If IsDirect then Inc(NCalcs) { 맮 - }
   else begin
    If FuncFlags and ffMethod<>0 then begin
     {  ।  ⮤ 㪠⥫   ꥪ }
     Inc(NCalcs);
    end;
    { NCalcs: । - +  - ( 뫮 -) +
     맮 - + । - -  CalcStack }
    Inc(NCalcs,Delta+NParVars+2);
    If not IsFunc then Dec(NCalcs) {   - - }
   end;
  end;
 end;

begin
 with ATerms[not CurTerm] do
  If TermWhat=Method_Flag then begin
   Q:=Ref; { Q ६ -  ࠭ PFuncCall }
   P:=PFuncCall(Q)^.Func
  end
  else P:=PHashCell(Ref)^.HData;

 ByRef:=False;
 With P^ do begin
  N:=NPars;
  If FuncFlags and ffSimpleIfAllConst=0 then ExNeed:=True;
  { ࠧ㬥,  SimpleIfAllConst  ࠢ쭮, ..    ExNeed }
  If FuncFlags and ffMethod<>0 then begin
   T^.Tail:=pointer(Q); { PFuncCall }
   with PFuncCall(Q)^ do begin
    {  ஢ PFunction - ꥪ  RefFunction }
    If CallFlags and cfVirtual<>0 then begin
     Inc(NCalcs); ByRef:=True
    end;
   end
  end
  else T^.Tail:=nil;
 end;

 If TopTerm^.TermType<>opLBra then
  If N=0 then begin { -  -  -  ᪮ }
   IncNCalcs(0); exit
  end
  else EJump0(teLBraExpected);

 If N=0 then begin { -  -,  -  ᪮ }
  GetTerm; { ய᪠ ( }
  CheckRBra;
  IncNCalcs(0); exit
 end;

 Inc(NBraL);
 K:=NewMemTmp(SizeOf(TExpression)*(N+1));
 K^[0].LocX:=0; K^[0].LocY:=0;
 T^.Head:=PTermTree(K); { 䠪᪨ - }
 { ࠭塞, .. TransFunc-४ᨢ    - FutureStrError }
 Old:=FutureStrError;
 FutureStrError:=teCommaExpected;

 For i:=1 to N do begin { 横  㬥⠬ }
  b:=True; { False, ᫨ ᫥ ࠡ⪨ - TopTerm 㪠-  ࠧ⥫ }
  GetTerm;
  Op:=TopTerm^.TermType; { 䠪. ⨯ }
  Op1:=P^.Pars[i].TermType; { ଠ ⨯ }
  Case Op1 of
   opFUknown:begin { Float  - }
    j:=NCalcs;
    K^[i].FTree:=TranslateExpression(False,False);
    If NCalcs=j then Inc(NCalcs);
    b:=False
   end;

   opSUknown:begin { string  祭 }
    { 塞 teCommaExpected  teRBraExpected }
    If i=N then FutureStrError:=teRBraExpected;
    K^[i].FTree:=TranslateStrExpression(False);
    b:=False
   end;

   opFPar:begin { Float  뫪 }
    Case Op of
     opFPar..opNewVar:begin
      If Op=opNewVar then { । ६ ⠭- opUknown }
       PHashCell(TopTerm^.Ref)^.TermType:=opFUknown;
      If PHashCell(TopTerm^.Ref)^.HFlags and off_ReadOnly<>0 then EJump0(teReadOnly);
      K^[i].NCalc:=0;
     end;
     opRefPar:begin
      K^[i].NCalc:=1;
      Inc(NCalcs);
      If PFieldRef(TopTerm^.Ref)^.FFlags and off_ReadOnly<>0 then EJump0(teReadOnly);
     end;
     else EJump1(teVarNameExpected);
    end;
    K^[i].FTree:=TopTerm^.Ref; { Hash ६ / PFieldRef }
   end;

   opSPar:begin { string  뫪 }
    Case Op of
     opSPar..opSUknown: begin
      If PHashCell(TopTerm^.Ref)^.HFlags and off_ReadOnly<>0 then EJump0(teReadOnly);
      K^[i].NCalc:=0;
     end;
     opRefString:begin
      K^[i].NCalc:=1;
      Inc(NCalcs);
      If PFieldRef(TopTerm^.Ref)^.FFlags and off_ReadOnly<>0 then EJump0(teReadOnly);
     end;
     else EJump1(teStringVarExpected);
    end;
    K^[i].FTree:=TopTerm^.Ref; { Hash ६ / PFieldRef }
   end;

   opObjectRef: begin { ꥪ⭠ 뫪 }
    Op1:=P^.Pars[i].Hash^.What; { ଠ ⨯ }
    If P^.Pars[i].UTFlag and utfByPar=0 then l:=0 else l:=1;
    b:=(Op=opOutSign);
    If b then begin
     If l=1 then EJump0(teObjectVarExpected);
     GetTerm;
     Op:=TopTerm^.TermType; { 䠪. ⨯ }
    end;
    K^[i].FTree:=TopTerm^.Ref;
    case Op of
     opObject,opObjectRef: K^[i].NCalc:=0;
     opRefObject,opRefObjectRef: begin
      K^[i].NCalc:=1; Inc(NCalcs)
     end;
     opNil:begin
      K^[i].NCalc:=0;
      If b then EJump0(teObjectVarExpected);
     end;
     else EJump1(teObjectVarExpected);
    end;
    case Op of
     opObjectRef,opRefObjectRef:begin
      If b then EJump0(teObjectVarExpected);
     end;
     else
      If l=1 then EJump0(teObjRefExpected);
    end;
    If (l=1) and (TopTerm^.TFlags<>0) then EJump0(teReadOnly);
    b:=True
   end;

   opObject: with TopTerm^ do begin { ꥪ }
    Op1:=P^.Pars[i].Hash^.What; { ଠ ⨯ }
    case Op of
     opObject,opObjectRef: K^[i].NCalc:=0;
     opRefObject,opRefObjectRef: begin
      K^[i].NCalc:=1; Inc(NCalcs)
     end;
     else EJump1(teObjectVarExpected);
    end;
    If not P2x2Object(CObjType)^.ObjectIsParent(Op1) then begin
     ErrorData:=Op1;
     EJump0(teUncompatibleObjectVar);
    end;
    K^[i].FTree:=Ref; {  ꥪ / PObjScan }
    If (P^.Pars[i].UTFlag and utfByPar<>0) and (TFlags<>0) then EJump0(teReadOnly);
    b:=True;
    case Op of
     opObjectRef,opRefObjectRef: begin { ꥪ⭠ 뫪 }
      GetTerm;
      With TopTerm^ do
       If (TermType=opFunc2) and (TermWhat=moPower) then
       else b:=False {ErrorJump(1,X,Y,teRefExpected)}
     end;
    end;
   end;

   opUserVar,opUserPar:begin { user type }
    b:=Op1=opUserPar;
    Op1:=P^.Pars[i].Hash^.What; { user type id }
    If not b then j:=NCalcs;
    K^[i].FTree:=TranslateUserExpression(Op1,True,b,K^[i].NCalc);
    If not b then begin
     If NCalcs=j then Inc(NCalcs);
    end
    else b:=False
   end;

   opArrayVar..opAnyArrVar: { array }
    If (Op=Op1) or ((Op1=opAnyArrVar) and OpIsArray(Op)) or EqualArrayType(Op,Op1) then begin
     K^[i].FTree:=pointer(TopTerm^.Ref); { PFieldRef / Hash 䠪᪮ ᨢ }
     If (Op=opRefArrayVar) or (Op=opRefStrArrVar) then begin
      K^[i].NCalc:=1;
      Inc(NCalcs)
     end
     else K^[i].NCalc:=0
    end
    else EJump1(teArrayNameExpected+Op1-opArrayVar);

   opUserFunc,opUserProc: { 楤 ࠬ }
    If ((Op1=opUserFunc) and ((Op=opUserFunc) or (Op=opParFunc))) or
       ((Op1=opUserProc) and ((Op=opUserProc) or (Op=opParProc)))
    then
     With TopTerm^ do begin
      Q:=PFunction(P^.Pars[i].Hash^.HData); { ଠ쭠 }
      F:=PFunction(PHashCell(Ref)^.HData);  { 䠪᪠ }
      If F^.FuncFlags and ffMethod<>0 then ErrorJump(0,X,Y,teMethodByArg);
      b:=(Q^.NPars<>F^.NPars); { ࠢ ᫮  ⨯ - }
      If not b then
       For j:=1 to Q^.NPars do b:=b or (Q^.Pars[j].TermType<>F^.Pars[j].TermType);
      If b then EJump0(teFuncMismatch);
      b:=True;
      K^[i].FTree:=Ref { Hash 䠪. - }
     end
    else begin
     If Op1=opUserFunc then i:=teFuncNameExpected else i:=teProcNameExpected;
     EJump1(i);
    end;

   opMultiVar:begin
    If Op<>opLBrack then EJump1(teLBrackExpected);
    GetTerm; { ய᪠ [ }
    Last:=nil;
    l:=0;  { 稪 - 䠪. - }
    While True do begin
     b:=TopTerm^.TermType=opOutSign; { ਧ ।  뫪 }
     If b then GetTerm; { ய᪠ @ }
     Op:=TopTerm^.TermType;
     If Op=opRBrack then break {  㪠   - }
     else begin
      Inc(l);
      NewMP;
     end;

     case Op of
      opStrArrVar,opSPar..opSConst,opStringConst,opRefString,
      opStringFunc,opParStrFunc,opDirectStrFunc:
      begin
       Last^.WhatExpr:=wmpStrMultiPar;
       If b then begin
        ExNeed:=True;
        Last^.ByValue:=False;
        Last^.Expr:=TopTerm^.Ref; { Hash/PFieldDef }
        case Op of
         opSPar..opSUknown:begin
          If PHashCell(TopTerm^.Ref)^.HFlags and off_ReadOnly<>0 then EJump0(teReadOnly);
          Last^.Aux:=0;
         end;
         opRefString:begin
          Last^.Aux:=1;
          Inc(NCalcs);
          If PFieldRef(TopTerm^.Ref)^.FFlags and off_ReadOnly<>0 then EJump0(teReadOnly);
         end;
         else EJump0(teStringVarExpected)
        end
       end
       else Last^.Expr:=TranslateStrExpression(False);
      end;

      opArrayDef:begin
       GetTerm;
       Op:=TopTerm^.TermType;
       ExNeed:=True;
       Last^.WhatExpr:=wmpArrayMultiPar;
       Last^.Expr:=TopTerm^.Ref; { Hash 䠪᪮ ᨢ / PFieldRef }
       case Op of
        opArrayVar..opAnyArrVar: Last^.Aux:=0;
        opRefArrayVar,opRefStrArrVar: begin
         Last^.Aux:=1; Inc(NCalcs)
        end;
        else EJump1(teArrayIdExpected)
       end;
       GetTerm; { ய⨬  ᨢ }
      end;

      opUserVar,opRefUser:begin
       Last^.WhatExpr:=TopTerm^.TermWhat; { User Type Id }
       If b then Last^.ByValue:=False;
       ExNeed:=True;
       Last^.Expr:=TopTerm^.Ref; { Hash ६ / PFieldRef }
       If Op=opUserVar then begin
        Last^.Aux:=0;
        If b and (PHashCell(TopTerm^.Ref)^.HFlags and off_ReadOnly<>0) then EJump0(teReadOnly);
       end
       else begin
        Last^.Aux:=1;
        Inc(NCalcs);
        If b and (PFieldRef(TopTerm^.Ref)^.FFlags and off_ReadOnly<>0) then EJump0(teReadOnly);
       end;
       GetTerm;
      end;

      opObject,opObjectRef,opRefObject,opRefObjectRef:begin
       If b then EJump0(teStaticObjExpected);
       Last^.WhatExpr:=wmpObject;
       ExNeed:=True;
       Last^.Expr:=TopTerm^.Ref; { Hash ६ / PObjScan }
       If (Op=opObject) or (Op=opObjectRef) then Last^.Aux:=0 else Last^.Aux:=1;
       GetTerm;
      end;

      else begin
       Last^.WhatExpr:=wmpFloatMultiPar;
       Case Op of
        opFPar..opNewVar:begin
         If b then begin {  뫪 }
          ExNeed:=True;
          Last^.Aux:=0;
          If Op=opNewVar then { । ६ ⠭- opUknown }
           PHashCell(TopTerm^.Ref)^.TermType:=opFUknown;
          If PHashCell(TopTerm^.Ref)^.HFlags and off_ReadOnly<>0 then EJump0(teReadOnly);
          Last^.ByValue:=False;
          Last^.Expr:=TopTerm^.Ref { 㪠-  Hash ६ }
         end
        end;
        opRefPar:
         If b then begin
          Last^.Aux:=1;
          Inc(NCalcs);
          Last^.ByValue:=False;
          Last^.Expr:=TopTerm^.Ref; { 㪠-  Hash ६ }
          If PFieldRef(TopTerm^.Ref)^.FFlags and off_ReadOnly<>0 then EJump0(teReadOnly);
         end;
        else
         If b then EJump1(teVarNameExpected)
       end; { case Op }

       If not b then begin {  祭 }
        j:=NCalcs;
        Last^.Expr:=TranslateExpression(False,False);
        If NCalcs=j then Inc(NCalcs);
       end
      end;
     end; { case Op }

     Case TopTerm^.TermType of
      opComma: GetTerm; { ய⨬ , }
      opRBrack: break;
      else EJump1(teRBrackExpected);
     end;
    end; { while }
    b:=True;
    K^[i].FTree:=pointer(Last);
    Inc(NCalcs,l);
    { K^[0].LocX - - 䠪᪨ ࠬ஢   ⨯- }
    Inc(K^[0].LocX,l);
   end; { of opMultiVar }

   opObjectType:begin { ꥪ ⨯ }
    If Op<>opObjectType then EJump1(teObjectTypeExpected);
    K^[i].FTree:=TopTerm^.Ref; { P2x2Object }
    K^[i].NCalc:=0
   end
  end; { case }

  If b then GetTerm; { 砥 ࠧ⥫  ᪮ }
  With TopTerm^ do
   Case TermType of
    opComma: If i=N then EJump0(teRBraExpected);
    opRBra:
     If i<P^.MinFactArgs then EJump0(teCommaExpected)
     else begin
      TransError:=teOK;
      Dec(NBraL);
      { - NRaL,   NBra, ..   砥 AA(X,8 ~)~ 뤠 teBraUnneccessary }
      GetTerm; { ய᪠ ) }
      K^[0].LocY:=i; { - 䠪᪨ 㬥⮢ }
      If i<>N then Inc(NCalcs);
      IncNCalcs(i);
      break
     end
    else begin
     If i=N then j:=teRBraExpected else j:=teCommaExpected;
     EJump1(j)
    end
   end;
 end; { for }
 FutureStrError:=Old;
end;

function TExprCompilator.TranslateExpression(PlusSearch,Back:boolean):PTermTree;
{  ᫮ ࠦ }
label 1;
var B:boolean; P,K:PTermTree; Op:OpsType; i:integer;
begin
 With TopTerm^ do begin
  Op:=TermType;
  GetTerm;
  Case Op of
   opLBra:begin
    Inc(NBraE);
    P:=TranslateExpression(False,False);
    CheckRBra; Dec(NBraE);
   end;

   opFPar..opFUknown:begin
    P:=NewMemTmp(SizeOf(TTermTree));
    With P^ do begin
     TermType:=Op;
     WhatR:=Ref;
     ExNeed:=True
    end
   end;

   opConst,opFConst:begin
    P:=NewMemTmp(SizeOf(TTermTree));
    With P^ do begin
     TermType:=Op; WhatR:=Ref;
    end;
   end;

   opFunc1{,opPolinom}:begin
    Inc(NCalcs);
    P:=NewMemTmp(SizeOf(TTermTree));
    With P^ do begin
     TermType:=Op;
     What:=TermWhat
    end;
    CheckLBra;
    Inc(NBraE);
    P^.Head:=TranslateExpression(False,False);
    CheckRBra;
    Dec(NBraE);
   end;

   opFunc2:begin
    If TermWhat=moMinus then begin
     Inc(NCalcs);
     P:=NewMemTmp(SizeOf(TTermTree));
     With P^ do begin
      What:=f1Neg; TermType:=opFunc1;
      Head:=TranslateExpression(False,True)
     end
    end
    else ErrorJump(0,X,Y,teEIE)
   end;

   opArrayVar,opRefArrayVar:begin
    Inc(NCalcs);
    If TopTerm^.TermType<>opLBrack then
     with TopTerm^ do ErrorJump(1,X,Y,teLBrackExpected);
    Inc(NBrack);
    P:=NewMemTmp(SizeOf(TTermTree));
    P^.WhatR:=Ref; {   ᨢ / PFieldRef }
    If Op=opRefArrayVar then Inc(NCalcs);

    With P^ do begin
     TermType:=Op;
     GetTerm; { ய᪠ [ }
     Head:=TranslateExpression(False,False);
     Case TopTerm^.TermType of
      opRBrack: Tail:=nil;
      opComma:begin
       GetTerm;
       Tail:=TranslateExpression(False,False)
      end
     end
    end;
    If TopTerm^.TermType<>opRBrack then EJump0(teRBrackExpected);
    Dec(NBrack);
    GetTerm;
    ExNeed:=True
   end;

   opUserFunc,opParFunc,opDirectFunc:begin
    P:=NewMemTmp(SizeOf(TTermTree));
    With P^ do begin
     TermType:=Op;
     WhatR:=Ref {   - / PFuncCall }
    end;
    TranslateFunc(P,True,Op=opDirectFunc);
    If Op=opParFunc then ExNeed:=True;
   end;

   opRefPar:begin
    P:=NewMemTmp(SizeOf(TTermTree));
    With P^ do begin
     TermType:=opRefPar;
     WhatR:=Ref; { PFieldRef }
     ExNeed:=True
    end;
    Inc(NCalcs);
   end;

   opFloatDef:begin
    CheckLBra;
    Inc(NBraL);
    P:=TranslateUserExpression(TUserVarType(TransError),False,False,word(i));
    Dec(NBraL);
    TransError:=0;
    CheckRBra;
   end;

   opYetDone:P:=LastTree;

   else begin
    case Op of
     opNewVar: i:=teUknownVar;
     else i:=ScanOp(Op,teFloatExpected,teEIE);
    end;
    ErrorJump(1,X,Y,i);
   end;
  end; { case }
 end; { with }

1:
 If Back and (TopTerm^.TermWhat<>moPower) then begin
  TranslateExpression:=P; exit
 end;

 With TopTerm^ do begin
  Op:=TermType;
  Case Op of
   opRBra:begin
    If NBraE=0 then
     If NBraL=0 then EJump0(teBraUnnecessary) else TransError:=teBraFromLogic
   end;

   opFunc2:begin
    Case TermWhat of
     moPlus..moMinus:B:=True
     else B:=False
    end;
    If B then
     If PlusSearch then begin
      TranslateExpression:=P; exit
     end;
    Inc(NCalcs);
    K:=NewMemTmp(SizeOf(TTermTree));
    With K^ do begin
     Head:=P;
     TermType:=opFunc2; What:=TermWhat
    end;
    GetTerm;
    K^.Tail:=TranslateExpression(B,not B);
    P:=K;
    goto 1
   end;

   {opSemiColon}opElse..opComma: ;
   else ErrorJump(0,X,Y,teEndExpected)
  end { case }
 end; { with }
 TranslateExpression:=P
end;

function TExprCompilator.TranslateStrExpression(Back:boolean):PTermTree;
{  ப ࠦ }
var Op:OpsType; P,K:PTermTree;
begin
 With TopTerm^ do begin
  Op:=TermType;
  P:=NewMemTmp(SizeOf(TTermTree));
  With P^ do begin
   TermType:=Op; WhatR:=Ref
  end;

  Case Op of
   opSPar,opSUknown:begin
    Inc(NCalcs);
    ExNeed:=True;
    GetTerm
   end;

   opStringConst,opSConst:begin
    Inc(NCalcs);
    GetTerm
   end;

   opParStrFunc,opStringFunc,opDirectStrFunc:begin
    GetTerm; { 室  ( }
    TranslateFunc(P,True,Op=opDirectStrFunc);
   end;

   opStrArrVar,opRefStrArrVar:begin
    GetTerm; { 砥 [ }
    If TopTerm^.TermType<>opLBrack then EJump1(teLBrackExpected);
    If Op=opRefStrArrVar then Inc(NCalcs);
    GetTerm; { ய᪠ [ }
    Inc(NCalcs);
    P^.Head:=TranslateExpression(False,False);
    P^.Tail:=nil; { ⮫쪮   - # ப }
    If TopTerm^.TermType<>opRBrack then EJump1(teRBrackExpected);
    ExNeed:=True;
    GetTerm; { ய᪠ ] }
   end;

   opRefString:begin
    ExNeed:=True;
    Inc(NCalcs);
    GetTerm;
   end;

   opNewVar: EJump0(teUknownVar);
   else EJump1(teStrExprExpected)
  end;
 end;

 While not Back do begin
  With TopTerm^ do
   Case TermType of
    {opSemiColon}opElse..opComma,opRBra: Back:=True;

    opFunc2:
     If TermWhat=moPlus then begin
      K:=NewMemTmp(SizeOf(TTermTree));
      K^.TermType:=opStrConcat;
      K^.Head:=P;
      Inc(NCalcs);
      GetTerm; { ய᪠ + }
      K^.Tail:=TranslateStrExpression(True);
      P:=K
     end
     else EJump0(teOpTypesMismatch);
    else EJump1(FutureStrError)
   end;
 end;
 TranslateStrExpression:=P
end;

procedure TExprCompilator.TranslateMath(Var P:TExpression; IsFunc:boolean);
var Op:OpsType; T:PTermTree;
begin
 With P do begin
  With TopTerm^ do begin
   LocX:=X; LocY:=Y
  end;
  NCalcs:=0; NBraE:=0; NBrack:=0;
  ExNeed:=False;

  If IsFunc then FTree:=TranslateExpression(False,False)
  else begin
   With TopTerm^ do begin
    Op:=TermType;
    T:=NewMemTmp(SizeOf(TTermTree));
    With T^ do begin
     TermType:=Op; WhatR:=Ref
    end;
   end;
   GetTerm; { 室  ( }
   TranslateFunc(T,False,Op=opDirectProc);
   FTree:=T
  end;
  NCalc:=NCalcs;
  If NCalc=0 then NCalc:=1;
 end
end;

procedure TExprCompilator.TranslateString(Var P:TExpression);
begin
 With P do begin
  With TopTerm^ do begin
   LocX:=X; LocY:=Y
  end;
  NCalcs:=0; NBraE:=0; NBrack:=0; ExNeed:=False;
  FTree:=TranslateStrExpression(False);
  NCalc:=NCalcs;
 end
end;

function TExprCompilator.TranslateRelation(var W:byte):PBoolExpression;
{  ࠦ ⭮襭 }
var P:PBoolExpression; N,i:integer; Loc:PToken; b,IsError:boolean;
    What:word; Op:OpsType;
begin
 P:=NewMemTmp(SizeOf(TBoolExpression));
 ErrorLevel:=0;
 N:=0;
 Loc:=TopTerm;
 case TopTerm^.TermType of
  opStrArrVar,opStringConst..opSConst,opParStrFunc,opStringFunc,opDirectStrFunc,
  opRefString,opRefStrArrVar:
   i:=LastrtFloat+1;
  opNil,opOutSign,opObject,opObjectRef,opRefObject,opRefObjectRef:
   i:=-1;
  else i:=0
 end;
 IsError:=False; { 뫠 teBraFromLogic ? }
 FutureStrError:=teRelExpected;
 FutureError:=teRelExpected;

 Repeat
  case i of
   -1: TranslateObjPar(P^.Left,tpObjRef{tpAny},What,Op);
    0: TranslateMath(P^.Left,True);
   else TranslateString(P^.Left);
  end;

  If TransError=teBraFromLogic then begin
   b:=False;
   IsError:=True;
   { 塞 opRBra  opYetDone }
   Inc(N,NCalcs);
   Inc(ErrorLevel);
   LastTree:=P^.Left.FTree;
   Dec(NBraL);
   ATerms[CurTerm].TermType:=opYetDone;
   TransError:=0;
  end
  else b:=True;
 until b;

 If N>0 then begin { 뫮 teBraFromLogic }
  P^.Left.NCalc:=N+NCalcs;
  with P^.Left do begin
   LocX:=Loc^.X; LocY:=Loc^.Y
  end;
 end
 else
  If IsError then { e.g. '(3)/2>8' }
   { 뫮 teBraFromLogic,  NCalcs['3)']=0, => N=0  P^.Left.LocX=3,  ୮ }
   with P^.Left do begin
    LocX:=Loc^.X; LocY:=Loc^.Y
   end;

 With TopTerm^ do
  Case TermType of
   opRel,opAssign:begin
    If i=-1 then begin
     If (TermType=opRel) and (TermWhat<>rtNE) then EJump0(teBadRelOpObj);
     P^.What:=TermWhat;
     N:=What;
     W:=etObjBool;
    end
    else begin
     P^.What:=TermWhat+i;
     W:=etBool;
    end;
    GetTerm; { ய᪠ - ࠢ }
    case i of
     -1: TranslateObjPar(P^.Right,N,What,Op);
      0: TranslateMath(P^.Right,True);
     else TranslateString(P^.Right);
    end;
    TransError:=0
   end;
   else EJump1(teRelExpected)
  end;
 TranslateRelation:=P
end;

function TExprCompilator.TranslateUserExpression(UserId:TUserVarType;
 Exactly,OnlyIdent:boolean; var ByRef:word):PTermTree;
{  ࠦ  ⨯ 짮⥫ }
var P:PTermTree; Op:OpsType;
begin
 ExNeed:=True;
 ByRef:=0;
 With TopTerm^ do begin
  Op:=TermType;
  case Op of
   opUserVar: { ६ ⨯ 짮⥫ }
    If Exactly and (TermWhat<>UserId) then EJump0(teUncompatibleUserVar)
    else begin
     If OnlyIdent then P:=Ref
     else begin
      P:=NewMemTmp(SizeOf(TTermTree));
      P^.TermType:=opFUknown;
      P^.WhatR:=Ref;
     end;
     GetTerm
    end;
   opUserType: { ⨯ 짮⥫ }
    If Exactly and (TermWhat<>UserId) then EJump0(teUncompatibleUserVar)
    else begin
     GetTerm; { 稬 ( }
     CheckLBra;
     Inc(NBraL);
     Op:=TopTerm^.TermType;
     case Op of
      opUserVar,opUserType,opRefUser:
       P:=TranslateUserExpression(UserId,False,OnlyIdent,ByRef);
      else begin
       If OnlyIdent then with TopTerm^ do
        case Op of
         opFPar..opFUknown,opRefPar:begin
          P:=pointer(Ref); {  ६/PFieldRef }
          If Op=opRefPar then begin
           ByRef:=1; Inc(NCalcs)
          end;
          GetTerm; { 稬 ) }
         end;
         opNewVar: EJump0(teUknownVar);
         else EJump1(teUserVarExpected)
        end { case }
       else P:=TranslateExpression(False,False);
      end
     end; { case }
     CheckRBra; Dec(NBraL);
     TransError:=0
    end;
   opRefUser:begin
    ByRef:=1;
    If Exactly and (TermWhat<>UserId) then EJump0(teUncompatibleUserVar);
    If OnlyIdent then P:=Ref
    else begin
     P:=NewMemTmp(SizeOf(TTermTree));
     P^.TermType:=opRefPar;
     P^.WhatR:=Ref; { PFieldRef }
    end;
    Inc(NCalcs);
    GetTerm;
   end;
   opNewVar: EJump0(teUknownVar);
   else EJump1(teUserVarExpected)
  end
 end;
 TranslateUserExpression:=P
end;

procedure TExprCompilator.TranslateUser(Var P:TExpression; UserId:TUserVarType);
var i:word;
begin
 With P do begin
  With TopTerm^ do begin
   LocX:=X; LocY:=Y
  end;
  NCalcs:=0; NBraE:=0; NBrack:=0;
  ErrorData:=UserId;
  FTree:=TranslateUserExpression(UserId,True,False,i);
  NCalc:=NCalcs;
  If NCalc=0 then NCalc:=1;
 end
end;

function TExprCompilator.TranslateLogic(LogSearch,Back:boolean):PLogicTree;
{  ᪮ ࠦ }
var P,K:PLogicTree; OldLogCalcs:word;
label 2;
begin
 Case TopTerm^.TermType of
  opLBra:begin
   OldLogCalcs:=NLogCalcs;
   Inc(NBraL);
   GetTerm; { ய᪠ ( }
   P:=TranslateLogic(False,False);
   If ErrorLevel<>0 then begin
    { 墠⨫ ᪮ (, ⭮  .ࠦ- - 室  譥 ४ᨨ }
    Dec(ErrorLevel);
    Back:=True
   end
   else
    If NBral<>0 then
     { NBraL / ࠢ 0, ᫨ ,  ᪮ ⭮  .ࠦ- }
     If TopTerm^.TermType<>opRBra then EJump0(teRBraExpected)
     else begin
      Dec(NBraL);
      GetTerm { ய᪠ ) }
     end
  end;

  opLogic:begin
   If TopTerm^.TermWhat=ltNOT then begin
    P:=NewMemTmp(SizeOf(TLogicTree));
    GetTerm; { ய᪠ NOT }
    Inc(NLogCalcs);
    With P^ do begin
     What:=etLogic; LogicOp:=ltNot;
     Left:=TranslateLogic(False,True)
    end
   end
   else EJump0(teEIE)
  end;

  opCompFunc:begin { IsTrue, IsFalse }
   P:=NewMemTmp(SizeOf(TLogicTree));
   Inc(NLogCalcs);
   with P^ do begin
    LogicOp:=TopTerm^.TermWhat;
    What:=etCompFunc;
    GetTerm; { 砥 ( }
    CheckLBra;
    Inc(NBraL);
    Left:=NewMemTmp(SizeOf(TExpression));
    TranslateMath(PExpression(Left)^,True);
    TransError:=teOK;
    CheckRBra; Dec(NBraL);
   end
  end;

  else begin
   P:=NewMemTmp(SizeOf(TLogicTree));
   With P^ do begin
    Inc(NLogCalcs);
    Left:=TranslateRelation(What);
    If ErrorLevel<>0 then begin
     Dec(ErrorLevel);
     Back:=True
    end;
   end
  end
 end; { case }

 If Back then begin
  TranslateLogic:=P; exit
 end;

2:
 With TopTerm^ do
  Case TermType of
   opRBra: If NBraL=0 then EJump0(teBraUnnecessary);

   opLogic:
    If TermWhat=ltNot then EJump0(teEIE)
    else
     If not LogSearch then begin
      K:=NewMemTmp(SizeOf(TLogicTree));
      Inc(NLogCalcs);
      With K^ do begin
       What:=etLogic; LogicOp:=TermWhat;
       Left:=P;
       GetTerm;
       Right:=TranslateLogic(True,False)
      end;
      P:=K;
      goto 2
     end;

   opDo..opThen,opSemiColon..opEndData: ;
   opIf..opEnd: TermType:=opBadLog;
   else EJump0(teEIE)
  end;
 TranslateLogic:=P
end;

procedure TExprCompilator.TranslateObjPar(Var T:TExpression; Flags:word; var What:word;
 var Op:OpsType);
var b:boolean; P:PTermTree; Op1:OpsType; i:integer;
begin
 P:=NewMemTmp(SizeOf(TTermTree));
 With T do begin
  with TopTerm^ do begin
   LocX:=X; LocY:=Y
  end;
  T.FTree:=P
 end;
 b:=TopTerm^.TermType=opOutSign;
 If b then GetTerm; { ய⨬ @ }

 With TopTerm^ do begin
  Case TermType of
   opObject,opRefObject: begin
    If not b and (Flags=tpObjRef) then EJump0(teAmperExpected);
    If b then What:=tpObjRef else What:=tpObj;
    Op:=P2x2Object(CObjType)^.ObjId;
    with P^ do begin
     TermType:=TermType; WhatR:=Ref {  PUserObject/PObjScan }
    end;
    GetTerm
   end;

   opObjectRef,opRefObjectRef: begin
    If b then EJump0(teObjectVarExpected);
    Op:=P2x2Object(CObjType)^.ObjId;
    with P^ do begin
     TermType:=TermType; WhatR:=Ref { PUserObject/PObjScan }
    end;
    GetTerm;
    b:=(TopTerm^.TermType=opFunc2) and (TopTerm^.TermWhat=moPower);
    If b then begin
     If Flags=tpObjRef then EJump0(teEIE);
     What:=tpObj;
     GetTerm
    end
    else
     If Flags=tpObj then EJump0(teRefExpected) else What:=tpObjRef
   end;

   opNil:begin
    If b then EJump0(teEIE);
    If Flags=tpObj then EJump0(teObjectVarExpected);
    Op:=0;
    with P^ do begin
     TermType:=opObjectRef; WhatR:=Ref { PUserObject/PObjScan }
    end;
    What:=tpObjRef;
    GetTerm
   end;

   else
    If Flags=tpObjRef then EJump1(teObjRefExpected) else EJump1(teObjectVarExpected)
  end
 end;
end;

function TExprCompilator.GetParNums:word;
begin
 GetParNums:=ParList^.Count
end;

procedure TExprCompilator.CheckRBra;
begin
 If TopTerm^.TermType<>opRBra then EJump1(teRBraExpected);
 GetTerm; { ய᪠ ) }
end;

procedure TExprCompilator.CheckLBra;
begin
 If TopTerm^.TermType<>opLBra then EJump1(teLBraExpected);
 GetTerm; { ய᪠ ( }
end;

procedure TExprCompilator.EJump0(i:integer);
begin
 with TopTerm^ do ErrorJump(0,x,y,i)
end;

procedure TExprCompilator.EJump1(i:integer);
begin
 with TopTerm^ do ErrorJump(1,x,y,i)
end;

function TExprCompilator.GetParDesc(Num:integer; Var IdDef:TIdDef):boolean;
var P:POutVar;
begin
 If Num>ParList^.Count then GetParDesc:=False
 else begin
  P:=ParList^.At(Num-1);
  with P^ do begin
   IdDef.Name:=@HVar^.Name;
   IdDef.Value:=@HVar^.ValueF;
   IdDef.F1:=F1; IdDef.F2:=F2
  end;
  GetParDesc:=True
 end
end;

begin
 Manager2x2:=New(P2x2Manager,Init);
end.
